// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from nao_command_msgs:msg/HeadLeds.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "nao_command_msgs/msg/head_leds.hpp"


#ifndef NAO_COMMAND_MSGS__MSG__DETAIL__HEAD_LEDS__TRAITS_HPP_
#define NAO_COMMAND_MSGS__MSG__DETAIL__HEAD_LEDS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "nao_command_msgs/msg/detail/head_leds__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace nao_command_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const HeadLeds & msg,
  std::ostream & out)
{
  out << "{";
  // member: intensities
  {
    if (msg.intensities.size() == 0) {
      out << "intensities: []";
    } else {
      out << "intensities: [";
      size_t pending_items = msg.intensities.size();
      for (auto item : msg.intensities) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const HeadLeds & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: intensities
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.intensities.size() == 0) {
      out << "intensities: []\n";
    } else {
      out << "intensities:\n";
      for (auto item : msg.intensities) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const HeadLeds & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace nao_command_msgs

namespace rosidl_generator_traits
{

[[deprecated("use nao_command_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const nao_command_msgs::msg::HeadLeds & msg,
  std::ostream & out, size_t indentation = 0)
{
  nao_command_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use nao_command_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const nao_command_msgs::msg::HeadLeds & msg)
{
  return nao_command_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<nao_command_msgs::msg::HeadLeds>()
{
  return "nao_command_msgs::msg::HeadLeds";
}

template<>
inline const char * name<nao_command_msgs::msg::HeadLeds>()
{
  return "nao_command_msgs/msg/HeadLeds";
}

template<>
struct has_fixed_size<nao_command_msgs::msg::HeadLeds>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<nao_command_msgs::msg::HeadLeds>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<nao_command_msgs::msg::HeadLeds>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // NAO_COMMAND_MSGS__MSG__DETAIL__HEAD_LEDS__TRAITS_HPP_
