// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from nao_command_msgs:msg/JointPositions.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "nao_command_msgs/msg/joint_positions.hpp"


#ifndef NAO_COMMAND_MSGS__MSG__DETAIL__JOINT_POSITIONS__TRAITS_HPP_
#define NAO_COMMAND_MSGS__MSG__DETAIL__JOINT_POSITIONS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "nao_command_msgs/msg/detail/joint_positions__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace nao_command_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const JointPositions & msg,
  std::ostream & out)
{
  out << "{";
  // member: indexes
  {
    if (msg.indexes.size() == 0) {
      out << "indexes: []";
    } else {
      out << "indexes: [";
      size_t pending_items = msg.indexes.size();
      for (auto item : msg.indexes) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: positions
  {
    if (msg.positions.size() == 0) {
      out << "positions: []";
    } else {
      out << "positions: [";
      size_t pending_items = msg.positions.size();
      for (auto item : msg.positions) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const JointPositions & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: indexes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.indexes.size() == 0) {
      out << "indexes: []\n";
    } else {
      out << "indexes:\n";
      for (auto item : msg.indexes) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: positions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.positions.size() == 0) {
      out << "positions: []\n";
    } else {
      out << "positions:\n";
      for (auto item : msg.positions) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const JointPositions & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace nao_command_msgs

namespace rosidl_generator_traits
{

[[deprecated("use nao_command_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const nao_command_msgs::msg::JointPositions & msg,
  std::ostream & out, size_t indentation = 0)
{
  nao_command_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use nao_command_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const nao_command_msgs::msg::JointPositions & msg)
{
  return nao_command_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<nao_command_msgs::msg::JointPositions>()
{
  return "nao_command_msgs::msg::JointPositions";
}

template<>
inline const char * name<nao_command_msgs::msg::JointPositions>()
{
  return "nao_command_msgs/msg/JointPositions";
}

template<>
struct has_fixed_size<nao_command_msgs::msg::JointPositions>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<nao_command_msgs::msg::JointPositions>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<nao_command_msgs::msg::JointPositions>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // NAO_COMMAND_MSGS__MSG__DETAIL__JOINT_POSITIONS__TRAITS_HPP_
